package model

import "gorm.io/gorm"

type CompleteSpu struct {
	gorm.Model
	StyleNumber string `gorm:"uniqueIndex; size:50; not null"`
	Title       Title  `gorm:"embedded;embeddedPrefix:title_"`
	Description string `gorm:"type:text"`
	Season      string `gorm:"size:20"`
	BrandId     string `gorm:"size:50"`
	Care        string `gorm:"type:text"`
	MadeIn      string `gorm:"size:50"`
	HsCode      string `gorm:"size:50"`

	// 外键
	// 多对一
	ColorSpus    ColorSpus    `gorm:"foreignKey:CompleteSpuStyleNumber; references:StyleNumber; constraint:OnUpdate:CASCADE,OnDelete:CASCADE;"`
	Products     Products     `gorm:"foreignKey:CompleteSpuStyleNumber; references:StyleNumber; constraint:OnUpdate:CASCADE,OnDelete:CASCADE;"`
	Compositions Compositions `gorm:"foreignKey:CompleteSpuStyleNumber; references:StyleNumber; constraint:OnUpdate:CASCADE,OnDelete:CASCADE;"`
	Skus         Skus         `gorm:"foreignKey:ColorSpuStyleNumber; references:StyleNumber; constraint:OnUpdate:CASCADE,OnDelete:CASCADE;"`
	Models       Models       `gorm:"foreignKey:CompleteSpuStyleNumber; references:StyleNumber; constraint:OnUpdate:CASCADE,OnDelete:CASCADE;"`
	Fits         Fits         `gorm:"foreignKey:CompleteSpuStyleNumber; references:StyleNumber; constraint:OnUpdate:CASCADE,OnDelete:CASCADE;"`
	// 多对多
	Genders    Genders    `gorm:"many2many:completespu_genders;foreignKey:StyleNumber; References:Code;"`
	Categories Categories `gorm:"many2many:completespu_categories;foreignKey:StyleNumber; References:Code;"`
}

type CompleteSpus []CompleteSpu

type Title struct {
	En string `gorm:"size:100"`
	Cn string `gorm:"size:100"`
}
